#jinja2:trim_blocks:False
{# Group mappings into services by the same scheme+host+port #}
{%- set services = [] %}
{%- for mapping in rps_mappings %}
  {%- set scheme = mapping["source"] | urlsplit("scheme") %}
  {%- set is_tls = true if scheme == 'https' else false %}
  {%- set default_port = is_tls | ternary(443, 80) %}
  {%- set port = mapping["source"] | urlsplit("port") | default(default_port, true) %}
  {%- set host = mapping["source"] | urlsplit("hostname") %}
  {%- set service_id = "{}://{}:{}".format(scheme, host, port) | hash("md5") %}

  {%- set group_by = {"new_group": true} %}
  {%- for service in services %}
    {%- if service["id"] == service_id %}
      {%- set _ = service["mappings"].append(mapping) %}
      {%- set _ = group_by.update({"new_group": false}) %}
    {%- endif %}
  {%- endfor %}

  {%- if group_by["new_group"] %}
    {%- set _ = services.append({
      "id": service_id,
      "scheme": scheme,
      "host": host,
      "port": port,
      "is_tls": is_tls,
      "mappings": [mapping]
    }) %}
  {%- endif %}
{%- endfor %}

# CACHE SETUP
{%- set cache_zone = "cache_" + (env_name | hash('md5')) %}

proxy_cache_path
  /var/cache/nginx
  levels=1:2
  keys_zone={{ cache_zone }}:10m
  max_size=10g
  inactive=10s
  use_temp_path=off;

###############################################################################
### UPSTREAMS DECLARATION
###############################################################################

{% include "nginx-upstreams.j2" %}

###############################################################################
### MODSEC CONFIG
###############################################################################

{%- if modsec_enabled %}
{% include "nginx-modsec.j2" %}
{%- endif %}

###############################################################################
### SAML CONFIG
###############################################################################

{%- if saml_enabled %}
{% include "nginx-saml.j2" %}
{%- endif %}

###############################################################################
### SERVER: DEFAULT 404
###############################################################################

server {
  listen 443 ssl default_server; # IPv4
  http2 on;

  {%- if acme_enabled %}
  ssl_certificate     /etc/nginx/certs/acme/default.pub;
  ssl_certificate_key /etc/nginx/certs/acme/default.key;
  {%- else %}
  ssl_certificate     /etc/nginx/certs/{{ cert_name }}.pem;
  ssl_certificate_key /etc/nginx/certs/{{ cert_name }}.key;
  {%- endif %}

  server_name _;
  server_name "";

  location / {
    return 404;
  }

  location ~* ^/nginx_status$ {
    # METRICS
    stub_status;
    access_log off;
    allow      127.0.0.1;
    deny       all;
  }

  location ~* ^/snet$ {
    # HEALTH CHECK
    error_log    off;
    access_log   off;

{%- if modsec_enabled %}
    modsecurity  off;
{%- endif %}

    return 200;
    break;
  }
}

{% for service in services %}
{% include "nginx-service.j2" %}
{% endfor %}
